diff --git a/configure.ac b/configure.ac
index 9f105a7..23ccaf8 100644
--- a/configure.ac
+++ b/configure.ac
@@ -119,21 +119,29 @@ if test "${SYS}" != "mingw32" ; then
 fi
 
 # dlopen check
+have_dlopen="no"
+if test "${SYS}" != "mingw32" ; then
+  have_dlopen="yes"
+else
+  AC_CHECK_FUNCS(
+    [dlopen],
+    [DLOPEN_LDFLAGS=""; have_dlopen="yes"],
+    [AC_CHECK_LIB([dl], [dlopen],
+       [DLOPEN_LDFLAGS="-ldl"; have_dlopen="yes"],
+       [have_dlopen="no"])])
+fi
+
 if [[ $use_dlopen_crypto_libs = "auto" ]]; then
-  if test "${SYS}" != "mingw32" ; then
-      AC_CHECK_LIB([dl], [dlopen],
-        [DLOPEN_LDFLAGS="-ldl"; AC_MSG_NOTICE($using_dlopen_crypto_libs)
-         AC_DEFINE([DLOPEN_CRYPTO_LIBS], [1], ["Define to 1 if dlopening crypto libs"])],
-        [use_dlopen_crypto_libs="no"; AC_MSG_NOTICE($using_normal_linking)])
-  else
-         AC_DEFINE([DLOPEN_CRYPTO_LIBS], [1], ["Define to 1 if dlopening crypto libs"])
+  use_dlopen_crypto_libs=$have_dlopen
+fi
+if [[ $use_dlopen_crypto_libs = "yes" ]]; then
+  if [[ $have_dlopen = "no" ]]; then
+    AC_MSG_ERROR($library_not_found)
   fi
-elif [[ $use_dlopen_crypto_libs = "yes" ]]; then
-  AC_CHECK_LIB([dl], [dlopen],
-    [DLOPEN_LDFLAGS="-ldl"; AC_MSG_NOTICE($using_dlopen_crypto_libs)
-     AC_DEFINE([DLOPEN_CRYPTO_LIBS], [1], ["Define to 1 if dlopening crypto libs"])],
-    [AC_MSG_ERROR($library_not_found)])
-else
+  AC_MSG_NOTICE($using_dlopen_crypto_libs)
+  AC_DEFINE([DLOPEN_CRYPTO_LIBS], [1], ["Define to 1 if dlopening crypto libs"])
+fi
+if [[ $use_dlopen_crypto_libs = "no" ]]; then
   AC_CHECK_LIB([aacs], [aacs_open],,
     [AC_MSG_ERROR($library_not_found)])
   AC_CHECK_LIB([bdplus], [bdplus_init],,